# 日志

> 日志由 [monolog/monolog](https://github.com/Seldaek/monolog) 提供支持。

## 配置文件

默认 `config/logger.php`。

``` php
<?php

declare(strict_types=1);

/*
 * This file is part of the coolephp/skeleton.
 *
 * (c) guanguans <ityaozm@gmail.com>
 *
 * This source file is subject to the MIT license that is bundled.
 */

use Monolog\Logger;

return [
    /*
     * 名称
     */
    'name' => 'app',

    /*
     * 级别
     */
    'level' => Logger::DEBUG,

    /*
     * 堆栈是否冒泡
     */
    'bubble' => true,

    /*
     * 日志文件权限
     */
    'file_permission' => null,

    /*
     * 日志文件
     */
    'log_file' => base_path('runtime/logs/app.log'),

    /*
     * 是否锁定日志文件
     */
    'use_locking' => false,

    /*
     * 格式化程序
     */
    'formatter' => [
        // 日志格式
        'format' => null,

        // 时间格式
        'date_format' => 'Y-m-d H:i:s',

        // 是否在日志条目中允许行内换行
        'allow_inline_Line_breaks' => false,

        // 是否忽略空上下文和额外内容
        'ignore_empty_context_and_extra' => false,
    ],
];
```

## 使用

``` php
use Guanguans\Coole\Facade\Logger;

Logger::log($level, $message, $context);
Logger::debug($level, $message, $context);
Logger::info($level, $message, $context);
Logger::notice($level, $message, $context);
Logger::warning($level, $message, $context);
Logger::error($level, $message, $context);
Logger::critical($level, $message, $context);
Logger::alert($level, $message, $context);
Logger::emergency($level, $message, $context);
```
