# 视图

模板引擎由 [twig/twig](https://github.com/twigphp/Twig) 提供支持。

## 配置文件

默认 `config/view.php`。

``` php
<?php

declare(strict_types=1);

/*
 * This file is part of the coolephp/skeleton.
 *
 * (c) guanguans <ityaozm@gmail.com>
 *
 * This source file is subject to the MIT license that is bundled.
 */

return [
    /*
     * 视图文件目录
     */
    'path' => base_path('view'),

    /*
     * 选项
     */
    'options' => [
        // Debug
        'debug' => false,

        // 字符集
        'charset' => 'UTF-8',

        // 是否忽略模板中的无效变量
        'strict_variables' => false,

        // 是否启用自动转义
        'autoescape' => 'html',

        // 缓存目录
        'cache' => base_path('runtime/views'),

        // 如果模板更改，是否重新加载模板
        'auto_reload' => null,

        // 优化
        'optimizations' => -1,
    ],
];
```

## 使用(详细使用请参考[twig](https://twig.symfony.com/))

### 控制器

``` php
<?php

class ViewController
{
    public function index()
    {
        return $this->render('index.html', ['name' => 'Coole']);
    }
}
```

### 模板文件

``` html
<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>view</title>
</head>
<body>
    <p>{{ name }}</p>
</body>
</html>
```
